/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

#include "houdini/houdini.pmh"

namespace fe
{

void SurfaceAccessibleHoudini::append(
	sp<SurfaceAccessibleI> a_spSurfaceAccessibleI,
	SpatialTransform& a_rTransform)
{
	feLog("SurfaceAccessibleHoudini::append\n");
	sp<SurfaceAccessibleHoudini> spSurfaceOther=
			a_spSurfaceAccessibleI;
	if(!spSurfaceOther.isValid())
	{
		//* TODO support cross copies
		feLog("SurfaceAccessibleHoudini::append"
				" not SurfaceAccessibleHoudini\n");
		return;
	}

	UT_Matrix4 utMatrix4(
			a_rTransform(0,0),a_rTransform(1,0),a_rTransform(2,0),0.0,
			a_rTransform(0,1),a_rTransform(1,1),a_rTransform(2,1),0.0,
			a_rTransform(0,2),a_rTransform(1,2),a_rTransform(2,2),0.0,
			a_rTransform(0,3),a_rTransform(1,3),a_rTransform(2,3),1.0);

	const GU_Detail* pOtherGdp=spSurfaceOther->gdp();
	GU_Detail copyGdp;
	copyGdp.duplicate(*pOtherGdp);
	copyGdp.transform(utMatrix4);
	const_cast<GU_Detail*>(m_pGdp)->merge(copyGdp);
}

void SurfaceAccessibleHoudini::instance(sp<SurfaceAccessibleI>
	a_spSurfaceAccessibleI,std::vector<SpatialTransform>& a_rTransformArray)
{
	//* TODO
}

} // namespace
