/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#include "math/math.h"

using namespace fe;

int main(void)
{
	UNIT_START();
	BWORD completed=FALSE;

	try
	{
		sp<DAGNode> spNode1(new DAGNode);
		sp<DAGNode> spNode2(new DAGNode);
		sp<DAGNode> spNode3(new DAGNode);
		sp<DAGNode> spNode4(new DAGNode);

		spNode3->attachTo(spNode1);
		spNode3->attachTo(spNode2);
		spNode4->attachTo(spNode2);

		UNIT_TEST(spNode1->parentCount()==0);
		UNIT_TEST(spNode1->childCount()==1);
		UNIT_TEST(spNode2->parentCount()==0);
		UNIT_TEST(spNode2->childCount()==2);
		UNIT_TEST(spNode3->parentCount()==2);
		UNIT_TEST(spNode3->childCount()==0);
		UNIT_TEST(spNode4->parentCount()==1);
		UNIT_TEST(spNode4->childCount()==0);

		spNode3->detach();
		spNode4->detachFrom(spNode1);
		spNode4->detachFrom(spNode2);

		UNIT_TEST(!spNode1->parentCount());
		UNIT_TEST(!spNode1->childCount());
		UNIT_TEST(!spNode2->parentCount());
		UNIT_TEST(!spNode2->childCount());
		UNIT_TEST(!spNode3->parentCount());
		UNIT_TEST(!spNode3->childCount());
		UNIT_TEST(!spNode4->parentCount());
		UNIT_TEST(!spNode4->childCount());

		completed=TRUE;
	}
	catch(Exception &e)	{ e.log(); }
	catch(...)			{ feLog("uncaught exception\n"); }

	UNIT_TEST(completed);
	UNIT_TRACK(17);
	UNIT_RETURN();
}
