#include "operator/operator.pmh"

namespace fe
{

void SurfaceAttrCreateOp::initialize(void)
{
	catalog< sp<Component> >("Input Surface");

	catalog<String>("Name");
	catalog<String>("Class")="Point";
	catalog<String>("Type")="Real";
	catalog<SpatialVector>("Default");
	catalog<bool>("Write Values")=false;
	catalog<SpatialVector>("Value");
}

void SurfaceAttrCreateOp::handle(Record& a_rSignal)
{
	feLog("SurfaceAttrCreateOp::handle\n");

	const String attrName="test";//catalog<String>("Name");
	if(attrName.empty())
	{
		feLog("SurfaceAttrCreateOp::handle no name\n");
		return;
	}
	const String attrClass=catalog<String>("Class");
	const String attrType=catalog<String>("Type");
	const SpatialVector& attrDefault=catalog<SpatialVector>("Default");

	//* TODO
	const BWORD attrWriteValues=catalog<bool>("Write Values");
	const SpatialVector& attrValue=catalog<SpatialVector>("Value");

	sp<SurfaceAccessibleI> spSurfaceAccessibleI=surfaceOutput(a_rSignal);
	FEASSERT(spSurfaceAccessibleI.isValid());

	sp<SurfaceAccessorI> spAccessor=spSurfaceAccessibleI->accessor(
			SurfaceAccessibleI::e_point,SurfaceAccessibleI::e_generic);
	FEASSERT(spAccessor.isValid());

	I32 pointCount=spAccessor->count();
	feLog("SurfaceAttrCreateOp::handle pointCount=%d\n",pointCount);

	spAccessor=spSurfaceAccessibleI->accessor(
			SurfaceAccessibleI::e_point,attrName);
	if(!spAccessor.isValid())
	{
		feLog("SurfaceAttrCreateOp::handle"
				" failed getting SurfaceAccessorI\n");
		return;
	}
	for(I32 index=0;index<pointCount;index++)
	{
		spAccessor->set(index,0,attrDefault[0]);
	}

	feLog("SurfaceAttrCreateOp::handle done\n");
}

} // namespace
