/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __grass_OperatorBlade_h__
#define __grass_OperatorBlade_h__

namespace fe
{

/**************************************************************************//**
	@brief Handler to crush curves based on a collider

	@ingroup grass
*//***************************************************************************/
class FE_DL_EXPORT BladeOp: public OperatorThreaded,
	public Initialize<BladeOp>
{
	public:

					BladeOp(void)											{}
virtual				~BladeOp(void)											{}

		void		initialize(void);

					//* As HandlerI
virtual	void		handle(Record& a_rSignal);

virtual	void		run(I32 a_id,Range a_range);

	private:

		sp<SurfaceAccessibleI>		m_spOutput;

		Blade						m_blade;

		std::vector<SpatialVector>	m_tangent;	// root direction
		std::vector<SpatialVector>	m_location;	// point locations
		std::vector<Real>			m_velocity;	// angular velocities
};

} /* namespace */

#endif /* __grass_OperatorBlade_h__ */

